'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var scrap = function () {
	var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
		var _this = this;

		var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
		var nbPage, lol, postes;
		return regeneratorRuntime.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						options.nbPage = options.nbPage || 0;

						nbPage = '?page=' + (options.nbPage + 1);
						_context2.next = 4;
						return (0, _got2.default)(baseUrl + '/offres-d-emploi.html' + nbPage);

					case 4:
						lol = _context2.sent;
						postes = getPostes(lol.body);
						_context2.next = 8;
						return Promise.all(postes.map(function () {
							var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee(poste) {
								var _ref3, body, posteDetail;

								return regeneratorRuntime.wrap(function _callee$(_context) {
									while (1) {
										switch (_context.prev = _context.next) {
											case 0:
												_context.next = 2;
												return (0, _got2.default)(poste.link);

											case 2:
												_ref3 = _context.sent;
												body = _ref3.body;
												posteDetail = getPostesDetail(body);
												return _context.abrupt('return', Object.assign(poste, posteDetail));

											case 6:
											case 'end':
												return _context.stop();
										}
									}
								}, _callee, _this);
							}));

							return function (_x3) {
								return _ref2.apply(this, arguments);
							};
						}()));

					case 8:
						return _context2.abrupt('return', _context2.sent);

					case 9:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, this);
	}));

	return function scrap(_x) {
		return _ref.apply(this, arguments);
	};
}();

var _got = require('got');

var _got2 = _interopRequireDefault(_got);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var baseUrl = 'http://www.vousmeritezcanalplus.com';

function getPostes(html) {
	var $ = _cheerio2.default.load(html);
	return $('li.offre_distribution').map(function (i, elem) {
		var date = $(elem).children('.date').text();
		var poste = $(elem).children('.titre').text();
		var link = '' + baseUrl + $(elem).children('.lien_offre').attr('href');
		return { date: date, poste: poste, link: link };
	}).get();
}

function getPostesDetail(html) {
	var $ = _cheerio2.default.load(html);
	var header = $('div#offerHeader');
	var contrat = header.children('.offerHeaderBloc').children('.typeContrat');
	var duree = header.children('.offerHeaderBloc').next().children().next().first();
	var context = header.next().next();
	var mission = context.next().next();
	var profil = mission.next().next();
	var niveau = profil.next().next();
	var experience = niveau.next().next();
	return {
		duree: duree.text(),
		contrat: contrat.text(),
		context: context.text(),
		mission: mission.text(),
		profil: profil.text(),
		niveau: niveau.text(),
		experience: experience.text()
	};
}

var mainExport = {
	scrap: scrap
};

exports.default = mainExport;

module.exports = mainExport;